version: 1

secrets:
  pg-credentials:
    string_data:
      username: synapse
      password: {{ derive_entropy(identifier="db_password") }}

containers:
  main:
    image: matrixdotorg/synapse:v1.119.0
    environment:
      SYNAPSE_CONFIG_PATH: /data/homeserver.yaml
    mounts:
      data:
        synapse/synapse: /data
    ingress_port: 8008
  postgres:
    image: postgres:16.1
    internal_ports:
      tcp:
        5432: 5432
    mounts:
      data:
        db/postgres: /var/lib/postgresql/data
    environment:
      POSTGRES_USER:
        secret: pg-credentials
        key: username
      POSTGRES_PASSWORD:
        secret: pg-credentials
        key: password
      POSTGRES_INITDB_ARGS: --encoding=UTF-8 --lc-collate=C --lc-ctype=C
  configure:
    image: harbor.nirvati.org/nirvati/synapse-init:latest
    job_type: OneTime
    restart: on-failure
    environment:
      POSTGRES_PASSWORD:
        secret: pg-credentials
        key: password
      POSTGRES_HOST: postgres.{{user}}-synapse.svc.cluster.local
      SYNAPSE_HOST: main.{{user}}-synapse.svc.cluster.local
      DOMAIN: {{init_domain}}
      INITIAL_USER_NAME: nirvati
      INITIAL_USER_PASSWORD: {{ derive_entropy(identifier="password") }}
    mounts:
      data:
        synapse/synapse: /data
